<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        //Common
        'name',
        'pays',
        'contact',
        'email',
        'password',
        'status',

        //Physic
        'prenomsP',
        'usernameP',
        'dateNaisP',
        'professionP',
        'quartierP',
        'villeP',
        'genreP',

        //Moral
        'numEM',
        'numIdentifM',
        'dateCreationM',
        'adresseM',
        'detailCompteM',
        'nomCompteM',
        'numCompteM',
        'nomBanqueM',
        'codeGuichetM',
        'ibanM',
        'bicSM',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}
